'use strict'

var RegexHelpers = require('../utils/regex-helper')

/**
 * Will extract all chord from markdown content
 * @type {[type]}
 */
module.exports = class ChordParser {
  constructor (opts) {
    this._root = (opts && opts.root) || null
    this._rootOverride = (opts && opts.rootOverride) || null
    this._flavors = (opts && opts.flavors) || null
  }

  parse (chord_string) {

    // root
    var char1 = chord_string.substring(0, 1)
    var char2 = chord_string.substring(1, 2)
    var root = char1
    var rootOverride = null
    if (char2 === 'b' || char2 === '#') {
      root = root + char2
    }

    // rootOverride
    var group_match = RegexHelpers.groupFromRegex(chord_string, /\/([ABCDEFG][b#]?)$/g, 1)
    if (group_match) {
      rootOverride = group_match
    }

    // -------------
    // get flavors
    // -------------
    var flavors = chord_string
    // remove root
    flavors = flavors.substring(root.length, flavors.length)
    // remove rootOverride
    if (rootOverride) {
      flavors = flavors.replace(/\/([ABCDEFG][b#]?)$/gm, '')
    }
    if (flavors.length === 0) {
      // if is empty is null then
      flavors = null
    }

    return {
      root: root,
      flavors: flavors,
      rootOverride: rootOverride
    }
  }

}
