'use strict'

var ChordParser = require('./chord-parser')
var RegexHelpers = require('../utils/regex-helper')

/**
 * Will extract all chord from markdown content
 * @type {[type]}
 */
module.exports = class ChordsConverter {
  constructor (opts) {
    opts = opts || {}
    this.chords = {}
    this.parser = new ChordParser()
  }

  getChordsList (line_content) {
    // https://regex101.com/r/kA6aZ9/1
    var matches = RegexHelpers.matchAllRegex(
      line_content,
      /\b([ABCDEFGAB][b#]?)([^\s]+)/g
    )

    var all_chords = []
    matches.forEach(function (match) {
      all_chords.push({
        chord: this.parser.parse(match[0]),
        loc: {
          start: match.index,
          size: match[0].length
        }
      })
    }.bind(this))

    return all_chords
  }
}
