'use strict'
/**
 * Will extract all chord from markdown content
 * @type {[type]}
 */
module.exports = class Extractor {
  constructor (opts) {
    opts = opts || {}
    this._md = opts.md || {}
    this._code_array = opts.code_array || []
    this._song = []
  }

  getSong () {
    this._extractCodeArray()
    this._extractChordLirics()
    this._cleanChordLirics()

    return this._song
  }

  _extractCodeArray () {
    var onlyCodeArray = []
    var isCode = false

    // content
    var content = this._md.content
    if (!content) {
      // no content, go away
      return null
    }

    var contentArray = content.split('\n')

    contentArray.forEach(function (item) {
                                // https://regex101.com/r/qR5tA8/1
      var matchOpenCloseCode = /\s*```/.test(item)
      if (matchOpenCloseCode) {
        // enter or leave code blocks
        isCode = !isCode
      } else if (isCode) {
        // is inside code block, get code
        onlyCodeArray.push(item)
      }

    })

    this._code_array = onlyCodeArray
  }

  _extractChordLirics () {
    for (let i = 0; i < this._code_array.length; i = i + 2) {
      let chord_line = this._code_array[i]
      let liric_line = ''
      if (i + 1 < this._code_array.length) {
        liric_line = this._code_array[i + 1]
      }
      this._song.push({
        chord: chord_line,
        liric: liric_line
      })
    }
  }

  _cleanChordLirics () {
    this._song.map(function (item) {
      item.chord = item.chord.replace(/^\s*'''/g, '')
      item.liric = item.liric.replace(/^\s*'''/g, '')
      return item
    })
  }
}
